#include <iostream>

class Zirkulaere_liste
{
public:
  class Element
  {
    public:
      Element(Element *naechstes_, int i_);
      void setze_naechstes(Element *naechstes_);
      Element *hole_naechstes(void) const;
      int hole_Wert(void) const;
    private:
      int i;
      Element *next;
  };

  Zirkulaere_liste(void);
  void einfuegen(int wert);
  void ListeZeigen(void) const;
  void l_loeschen(void);
  
private:
  Element *erstes_El;
};


Zirkulaere_liste::Zirkulaere_liste(void) : erstes_El(0)
{
}

void Zirkulaere_liste::einfuegen(int wert)
{
  if(!erstes_El)
  {
    erstes_El=new Element(0, wert);
    erstes_El->setze_naechstes(erstes_El);
  }
  else
  {
    Element *letztes=erstes_El;
    while(letztes->hole_naechstes()!=erstes_El)
    {
      ++letztes;
    }    
    erstes_El=new Element(erstes_El, wert);
    letztes->setze_naechstes(erstes_El);
  }

}

void Zirkulaere_liste::ListeZeigen(void) const
{
  const Element *aktuelles=erstes_El;

  if(aktuelles)
  {
    do
    {
      std::cout << aktuelles->hole_Wert() << " ";
      aktuelles=aktuelles->hole_naechstes();
    } while(aktuelles!=erstes_El);
  }    
}

void Zirkulaere_liste::l_loeschen(void)
{
  Element *temp=erstes_El, *erstes_El_=erstes_El;

  if(temp)
  {
    do
    {
      temp=erstes_El->hole_naechstes();
      delete erstes_El;
      erstes_El=temp;
    }while(temp!=erstes_El_);
  }
  erstes_El=0;
}


Zirkulaere_liste::Element::Element(Element *naechstes_, int i_=0) :  i(i_), next(naechstes_)
{
}

void Zirkulaere_liste::Element::setze_naechstes(Element *naechstes_)
{
  next=naechstes_;
}

Zirkulaere_liste::Element *Zirkulaere_liste::Element::hole_naechstes(void) const
{
  return(next);
}

int Zirkulaere_liste::Element::hole_Wert(void) const
{
  return(i);
}

int main(void)
{
  Zirkulaere_liste l;

  for(int i=10; i>0; --i)
  {
    l.einfuegen(i);
  }
  l.ListeZeigen();
  std::cout << "\n";
  l.l_loeschen();
  l.ListeZeigen();
  std::cout << "\n";
  l.l_loeschen();

  return(0);
}